"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.MenuBotPlugin = void 0;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _get2 = _interopRequireDefault(require("@babel/runtime/helpers/get"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _createKeyboard = require("@lskjs/bots-base/utils/createKeyboard");

var _botsPlugin = _interopRequireDefault(require("@lskjs/bots-plugin"));

var _uniqBy = _interopRequireDefault(require("lodash/uniqBy"));

var _telegraf = require("telegraf");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var MenuBotPlugin = /*#__PURE__*/function (_BaseBotPlugin) {
  (0, _inherits2["default"])(MenuBotPlugin, _BaseBotPlugin);

  var _super = _createSuper(MenuBotPlugin);

  function MenuBotPlugin() {
    var _this;

    (0, _classCallCheck2["default"])(this, MenuBotPlugin);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    _this.providers = ['telegram'];
    return _this;
  }

  (0, _createClass2["default"])(MenuBotPlugin, [{
    key: "getButton",
    value: function getButton(element) {
      var itemValue = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'none';
      var type = element.type,
          title = element.title,
          value = element.value;
      var config = value === 'array' ? [title, itemValue] : [title, value];
      var btn = type === 'url' ? _telegraf.Markup.urlButton.apply(_telegraf.Markup, config) : _telegraf.Markup.callbackButton.apply(_telegraf.Markup, config);
      return btn;
    }
  }, {
    key: "getMenu",
    value: function () {
      var _getMenu = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(key, itemValue) {
        var _this2 = this;

        var BotsMenuModel, menu, buttonsLayout, keyboard;
        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return this.botsModule.model('BotsMenuModel');

              case 2:
                BotsMenuModel = _context.sent;
                _context.next = 5;
                return BotsMenuModel.findOne({
                  key: key
                }).select(['content', 'buttonsLayout']).lean();

              case 5:
                menu = _context.sent;

                if (menu) {
                  _context.next = 8;
                  break;
                }

                return _context.abrupt("return", []);

              case 8:
                buttonsLayout = menu.buttonsLayout.map(function (element) {
                  if (Array.isArray(element)) {
                    var buttons = element.map(function (item) {
                      return _this2.getButton(item, itemValue);
                    });
                    return buttons;
                  }

                  return _this2.getButton(element, itemValue);
                });
                keyboard = _telegraf.Markup.inlineKeyboard(buttonsLayout);
                return _context.abrupt("return", [menu.content.text, keyboard]);

              case 11:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function getMenu(_x, _x2) {
        return _getMenu.apply(this, arguments);
      }

      return getMenu;
    }()
  }, {
    key: "onMenu",
    value: function () {
      var _onMenu = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(_ref) {
        var bot, ctx, path, menu, content, keyboard, extra;
        return _regenerator["default"].wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                bot = _ref.bot, ctx = _ref.ctx, path = _ref.path, menu = _ref.route;

                if (menu) {
                  _context2.next = 4;
                  break;
                }

                this.log.warn('!menu', path);
                return _context2.abrupt("return", false);

              case 4:
                this.log.trace('menu', path, menu);
                content = menu.content, keyboard = menu.keyboard;
                extra = {};

                if (keyboard) {
                  extra = (0, _createKeyboard.createKeyboard)(keyboard); // console.log('extra', extra.reply_markup.inline_keyboard);
                }

                _context2.next = 10;
                return bot.replyContent(ctx, content, extra);

              case 10:
                return _context2.abrupt("return", true);

              case 11:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function onMenu(_x3) {
        return _onMenu.apply(this, arguments);
      }

      return onMenu;
    }()
  }, {
    key: "getRoutes",
    value: function () {
      var _getRoutes = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3() {
        var _this3 = this;

        return _regenerator["default"].wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                return _context3.abrupt("return", this.menus.map(function (_ref2) {
                  var path = _ref2.path,
                      other = (0, _objectWithoutProperties2["default"])(_ref2, ["path"]);
                  return _objectSpread({
                    path: path,
                    action: _this3.onMenu.bind(_this3)
                  }, other);
                }));

              case 1:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function getRoutes() {
        return _getRoutes.apply(this, arguments);
      }

      return getRoutes;
    }()
  }, {
    key: "init",
    value: function () {
      var _init = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee4() {
        return _regenerator["default"].wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                _context4.next = 2;
                return (0, _get2["default"])((0, _getPrototypeOf2["default"])(MenuBotPlugin.prototype), "init", this).call(this);

              case 2:
                _context4.next = 4;
                return this.getMenus();

              case 4:
                this.menus = _context4.sent;

              case 5:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function init() {
        return _init.apply(this, arguments);
      }

      return init;
    }()
  }, {
    key: "run",
    value: function () {
      var _run = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee5() {
        return _regenerator["default"].wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                _context5.next = 2;
                return (0, _get2["default"])((0, _getPrototypeOf2["default"])(MenuBotPlugin.prototype), "run", this).call(this);

              case 2:
                _context5.next = 4;
                return this.getMenus();

              case 4:
                this.menus = _context5.sent;

              case 5:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function run() {
        return _run.apply(this, arguments);
      }

      return run;
    }()
  }, {
    key: "getMenus",
    value: function () {
      var _getMenus = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee6() {
        var configMenus;
        return _regenerator["default"].wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                configMenus = this.config && this.config.menus || [];
                _context6.t0 = _uniqBy["default"];
                _context6.t1 = [];
                _context6.t2 = (0, _toConsumableArray2["default"])(configMenus);
                _context6.t3 = _toConsumableArray2["default"];
                _context6.next = 7;
                return this.getMenusFromDb();

              case 7:
                _context6.t4 = _context6.sent;
                _context6.t5 = (0, _context6.t3)(_context6.t4);
                _context6.t6 = _context6.t1.concat.call(_context6.t1, _context6.t2, _context6.t5);

                _context6.t7 = function (m) {
                  return m.path;
                };

                return _context6.abrupt("return", (0, _context6.t0)(_context6.t6, _context6.t7));

              case 12:
              case "end":
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function getMenus() {
        return _getMenus.apply(this, arguments);
      }

      return getMenus;
    }()
  }, {
    key: "getMenusFromDb",
    value: function () {
      var _getMenusFromDb = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee7() {
        var BotsMenuModel;
        return _regenerator["default"].wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                _context7.prev = 0;
                _context7.next = 3;
                return this.botsModule.module('models.BotsMenuModel');

              case 3:
                BotsMenuModel = _context7.sent;
                return _context7.abrupt("return", BotsMenuModel.find().lean());

              case 7:
                _context7.prev = 7;
                _context7.t0 = _context7["catch"](0);
                this.log.error('getMenusFromDb', _context7.t0);
                return _context7.abrupt("return", []);

              case 11:
              case "end":
                return _context7.stop();
            }
          }
        }, _callee7, this, [[0, 7]]);
      }));

      function getMenusFromDb() {
        return _getMenusFromDb.apply(this, arguments);
      }

      return getMenusFromDb;
    }() // run() {
    //   super.run();
    //   const { type, title, value } = element;
    //   const config = value === 'array' ? [title, itemValue] : [title, value];
    //   const btn = type === 'url' ? Markup.urlButton(...config) : Markup.callbackButton(...config);
    //   return btn;
    // }

  }]);
  return MenuBotPlugin;
}(_botsPlugin["default"]);

exports.MenuBotPlugin = MenuBotPlugin;
var _default = MenuBotPlugin;
exports["default"] = _default;
//# sourceMappingURL=MenuBotPlugin.js.map